/****** Object:  StoredProcedure [dbo].[SP_CED_SubmitEmergencyOrderCreation]    Script Date: 9/29/2022 4:15:59 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[SP_CED_SubmitEmergencyOrderCreation] @ArrivalDateTime DATETIME = '2019-08-20 18:13:00'
	,@Username VARCHAR(50) = 'IPPCS.Admin'
	,@SessionID VARCHAR(50) = '0hy3yzaiyx2dddhtxhs2lpdn'
AS
BEGIN
	DECLARE @T AS TABLE (PID BIGINT)
	DECLARE @pid AS BIGINT = 0
	DECLARE @log AS VARCHAR(MAX)
	DECLARE @MODULE_ID AS VARCHAR(1) = '2'
	DECLARE @FUNCTION_ID AS VARCHAR(5) = '23003'
	DECLARE @R_SEQ_NO INT
	DECLARE @TB_T_LOG_D AS TABLE (
		PROCESS_ID BIGINT
		,SEQUENCE_NUMBER INT
		,MESSAGE_ID VARCHAR(12)
		,MESSAGE_TYPE VARCHAR(3)
		,[MESSAGE] VARCHAR(MAX)
		,LOCATION VARCHAR(MAX)
		,CREATED_BY VARCHAR(20)
		,CREATED_DATE DATETIME
		)

	SET @log = 'Starting [Insert Emergency Order]';

	INSERT @T
	EXEC dbo.sp_PutLog @log
		,@Username
		,'InsertEmergencyOrder.init'
		,@pid OUTPUT
		,'MPCS00002INF'
		,'INF'
		,@MODULE_ID
		,@FUNCTION_ID;

	BEGIN TRY
		BEGIN TRANSACTION IPPCSInsertEmergencyOrder

  --** Start : Add by FID.Andri (2022-09-29) -> Get Dock of EO
  IF OBJECT_ID('tempdb..#tmpSplitStringDock') IS NOT NULL
    DROP TABLE #tmpSplitStringDock

  CREATE TABLE #tmpSplitStringDock
  ( 
    dock_cd VARCHAR(MAX)
  )

  DECLARE @SYSTEM_VALUE VARCHAR(1000)
  SELECT @SYSTEM_VALUE=[SYSTEM_VALUE] FROM [dbo].[TB_M_SYSTEM] WHERE [FUNCTION_ID]='DOCK_PACKING' AND [SYSTEM_CD]='EMERGENCY_ORDER'

  INSERT  INTO #tmpSplitStringDock(dock_cd)
  EXEC dbo.SplitString @SYSTEM_VALUE, ''
  --** End : Add

		/* Start 2019-02-13 FID.Ridwan */
		IF OBJECT_ID('tempdb..#EMERGENCY_ORDER_PART') IS NOT NULL
			DROP TABLE #EMERGENCY_ORDER_PART

		IF OBJECT_ID('tempdb..#RESULTMANIFEST') IS NOT NULL
			DROP TABLE #RESULTMANIFEST

		/* End 2019-02-13 FID.Ridwan */
		CREATE TABLE #EMERGENCY_ORDER_PART (
			ID INT IDENTITY
			,SUPPLIER_CD VARCHAR(6)
			,SUPPLIER_PLANT CHAR(1)
			,DOCK_CD VARCHAR(2)
			)

		CREATE TABLE #RESULTMANIFEST (
			MANIFEST_NO VARCHAR(16)
			,ORDER_NO VARCHAR(12)
			,DOCK_CD VARCHAR(2)
			)

		DECLARE @MANIFEST_NO VARCHAR(16)
			,@ORDER_NO VARCHAR(12)
			,@SUPPLIER_CD VARCHAR(6)
			,@SUPPLIER_PLANT CHAR(1)
			,@DOCK_CD VARCHAR(2)
			,@RCV_PLANT_CD CHAR(1)
			,@SHIPPING_DOCK CHAR(3)
			,@PLANT_NM VARCHAR(30)
			,@COMPANY_CD VARCHAR(4)
			,@DATE_NOW_STRING VARCHAR(8)
			,@DATE_NOW DATETIME
			,@PC_ADDRESS_FINAL VARCHAR(17)
			,@BUILD_OUT_QTY VARCHAR(7)
			,@cntEMERGENCY_ORDER_PART INT
			,@iEMERGENCY_ORDER_PART INT
			,@PROGRESS_LANE_NO VARCHAR(5)
			,@CONVEYANCE_NO VARCHAR(5)

		SELECT @DATE_NOW = GETDATE()

		SELECT @DATE_NOW_STRING = CONVERT(VARCHAR(8), @DATE_NOW, 112)

		INSERT INTO #EMERGENCY_ORDER_PART
		SELECT DISTINCT SUPPLIER_CD
			,SUPPLIER_PLANT
			,DOCK_CD
		FROM TB_T_CED_EMERGENCY_ORDER_PART
		WHERE SessionID = @SessionID
			AND UserID = @Username

		--SELECT * FROM #EMERGENCY_ORDER_PART
		--PRINT 1
		SELECT @cntEMERGENCY_ORDER_PART = COUNT(*)
		FROM #EMERGENCY_ORDER_PART

		--PRINT 2
		SET @iEMERGENCY_ORDER_PART = 1

		/* Start 2019-02-13 FID.Ridwan */
		DELETE
		FROM TB_T_DAILY_ORDER_MANIFEST
		WHERE CREATED_BY = @Username

		DELETE
		FROM TB_T_DAILY_ORDER_PART
		WHERE CREATED_BY = @Username

		/* End 2019-02-13 FID.Ridwan */
		WHILE @iEMERGENCY_ORDER_PART <= @cntEMERGENCY_ORDER_PART
		BEGIN
			--PRINT 3
			SET @log = 'Iteration : ' + CAST(@iEMERGENCY_ORDER_PART AS VARCHAR);

			INSERT INTO @TB_T_LOG_D
			SELECT @pid
				,NULL
				,'MPCS00002INF'
				,'INF'
				,@log
				,'Insert Emergency Order'
				,@Username
				,GETDATE()

			SELECT @SUPPLIER_CD = SUPPLIER_CD
				,@SUPPLIER_PLANT = SUPPLIER_PLANT
				,@DOCK_CD = DOCK_CD
			FROM #EMERGENCY_ORDER_PART
			WHERE ID = @iEMERGENCY_ORDER_PART --+ 1
				--SELECT @iEMERGENCY_ORDER_PART AS emergency0rderPart
				--PRINT 4

			SELECT @RCV_PLANT_CD = d.PLANT_CD
				,@COMPANY_CD = d.COMPANY_CD
				,@PLANT_NM = p.PLANT_NM
			FROM TB_M_DOCK d
			INNER JOIN TB_M_PLANT p ON d.PLANT_CD = p.PLANT_CD
			WHERE d.DOCK_CD = @DOCK_CD

			--SELECT @DOCK_CD AS DoCK_CD
			--PRINT 5
			SELECT @SHIPPING_DOCK = SHIPPING_DOCK
			FROM TB_M_UTIL_PLANE
			WHERE SUPPLIER_CD = @SUPPLIER_CD
				AND SUPPLIER_PLANT = @SUPPLIER_PLANT
				AND DOCK_CD = @DOCK_CD

			--PRINT 6
			SELECT @MANIFEST_NO = dbo.fn_getmanifestno_emergency_v2(@RCV_PLANT_CD, @Username) --dbo.fn_getmanifestno_emergency(@RCV_PLANT_CD)

			--SELECT @RCV_PLANT_CD AS RCV_PLANT
			--SELECT @MANIFEST_NO AS maniFest
			--PRINT 7
			SET @log = 'Manifest No for Emergency Order : ' + @MANIFEST_NO;

			INSERT INTO @TB_T_LOG_D
			SELECT @pid
				,NULL
				,'MPCS00002INF'
				,'INF'
				,@log
				,'Insert Emergency Order'
				,@Username
				,GETDATE()

			--SELECT @ORDER_NO = dbo.fn_getorderno_emergency_v2(@Username) --dbo.fn_getorderno_emergency()
			
			SELECT TOP 1 @ORDER_NO = dbo.fn_getorderno_emergency_v2(@Username, A.PROD_DATE) 
			FROM TB_T_CED_EMERGENCY_ORDER_PART A
			WHERE A.SessionID = @SessionID
				AND A.UserID = @Username
				AND A.SUPPLIER_CD = @SUPPLIER_CD
				AND A.SUPPLIER_PLANT = @SUPPLIER_PLANT
				AND A.DOCK_CD = @DOCK_CD
			ORDER BY A.PROD_DATE DESC

			--SELECT @DOCK_CD 
			--PRINT 8
			SET @log = 'Order No for Emergency Order : ' + @ORDER_NO;

			INSERT INTO @TB_T_LOG_D
			SELECT @pid
				,NULL
				,'MPCS00002INF'
				,'INF'
				,@log
				,'Insert Emergency Order'
				,@Username
				,GETDATE()

			SELECT @PROGRESS_LANE_NO = PROGRESS_LANE_NO
				,@CONVEYANCE_NO = CONVEYANCE_NO
			FROM TB_T_CED_EMERGENCY_ORDER_PART
			WHERE SessionID = @SessionID
				AND UserID = @Username
				AND SUPPLIER_CD = @SUPPLIER_CD
				AND SUPPLIER_PLANT = @SUPPLIER_PLANT
				AND DOCK_CD = @DOCK_CD

			--SET @PROGRESS_LANE_NO = (SELECT PROGRESS_LANE_NO FROM TB_T_EMERGENCY_ORDER_PART
			--WHERE SessionID=@SessionID AND UserID=@Username AND
			--	SUPPLIER_CD=@SUPPLIER_CD AND
			--	SUPPLIER_PLANT=@SUPPLIER_PLANT AND
			--	DOCK_CD=@DOCK_CD)			
			--PRINT 9	
			--SET @CONVEYANCE_NO = (SELECT CONVEYANCE_NO FROM TB_T_EMERGENCY_ORDER_PART
			--WHERE SessionID=@SessionID AND UserID=@Username AND
			--	SUPPLIER_CD=@SUPPLIER_CD AND
			--	SUPPLIER_PLANT=@SUPPLIER_PLANT AND
			--	DOCK_CD=@DOCK_CD)	
			--PRINT 10
			INSERT INTO TB_T_DAILY_ORDER_MANIFEST (
				ORDER_NO
				,MANIFEST_NO
				,SUPPLIER_CD
				,SUPPLIER_PLANT
				,ORDER_TYPE
				,ORDER_RELEASE_DT
				,RCV_PLANT_CD
				,DOCK_CD
				,P_LANE_CD
				,P_LANE_SEQ
				,ARRIVAL_PLAN_DT
				,TOTAL_ITEM
				,TOTAL_QTY
				,SHIPPING_DOCK
				,SHIPPING_DT
				,SUB_ROUTE_CD
				,SUB_ROUTE_SEQ
				,SUB_ROUTE_DT
				,FST_X_DOCK_DEPART_DT
				,COMPANY_CD
				,CAR_FAMILY_CD
				,RE_EXPORT_CD
				,CANCEL_FLAG
				,MANIFEST_RECEIVE_FLAG
				,PROBLEM_FLAG
				,ICS_FLAG
				,ICS_DT
				,CREATED_BY
				,CREATED_DT
				,FTP_FLAG
				,CONVEYANCE_ROUTE
				)
			SELECT @ORDER_NO
				,@MANIFEST_NO
				,REPLACE(@SUPPLIER_CD, ' ', '')
				,REPLACE(@SUPPLIER_PLANT, ' ', '')
				,'2'
				,@DATE_NOW_STRING
				,@RCV_PLANT_CD
				,@DOCK_CD
				,''
				,@PROGRESS_LANE_NO
				/* Start 2019-02-13 FID.Ridwan */
				,@ArrivalDateTime
				--,CASE 
				--	WHEN MAX(A.SUBMIT_TYPE) = '1'
				--		AND ISNULL(MAX(A.PART_BARCODE), '') <> ''
				--		AND ISNULL(MAX(A.PROD_DATE), '1900-01-01') = '1900-01-01'
				--		THEN @ArrivalDateTime
				--	WHEN MAX(A.SUBMIT_TYPE) = '1'
				--		AND ISNULL(MAX(A.PART_BARCODE), '') <> ''
				--		AND ISNULL(MAX(A.PROD_DATE), '1900-01-01') <> '1900-01-01'
				--		THEN CONVERT(DATETIME, CONVERT(VARCHAR, CONVERT(DATE, MAX(A.PROD_DATE), 103), 23) + ' ' + CONVERT(VARCHAR, MAX(@ArrivalDateTime), 8))
				--	WHEN MAX(A.SUBMIT_TYPE) = '1'
				--		AND ISNULL(MAX(A.PART_BARCODE), '') = ''
				--		AND ISNULL(MAX(A.PROD_DATE), '1900-01-01') <> '1900-01-01'
				--		THEN CONVERT(DATETIME, CONVERT(VARCHAR, CONVERT(DATE, MAX(A.PROD_DATE), 103), 23) + ' ' + CONVERT(VARCHAR, MAX(@ArrivalDateTime), 8))
				--	WHEN MAX(A.SUBMIT_TYPE) = '2'
				--		THEN @ArrivalDateTime
				--	END
				/* End 2019-02-13 FID.Ridwan */
				,COUNT('')
				,SUM(A.ORDER_QTY)
				,@SHIPPING_DOCK
				,CASE 
					WHEN REPLACE(@SUPPLIER_CD, ' ', '') IN (
							'5022'
							,'5165'
							)
						THEN @ArrivalDateTime
					ELSE NULL
					END
				,CASE 
					WHEN REPLACE(@SUPPLIER_CD, ' ', '') IN (
							'5022'
							,'5165'
							)
						THEN 'DS06'
					ELSE NULL
					END
				,CASE 
					WHEN REPLACE(@SUPPLIER_CD, ' ', '') IN (
							'5022'
							,'5165'
							)
						THEN '2'
					ELSE NULL
					END
				,CASE 
					WHEN REPLACE(@SUPPLIER_CD, ' ', '') IN (
							'5022'
							,'5165'
							)
						THEN @ArrivalDateTime
					ELSE NULL
					END
				,CASE 
					WHEN REPLACE(@SUPPLIER_CD, ' ', '') IN (
							'5022'
							,'5165'
							)
						THEN @ArrivalDateTime
					ELSE NULL
					END
				,@COMPANY_CD
				,''
				,''
				,0
				,0
				,0
				,0
				,NULL
				,@Username
				,GETDATE()
				,0
				,@CONVEYANCE_NO
			FROM TB_T_CED_EMERGENCY_ORDER_PART A
			WHERE A.SessionID = @SessionID
				AND A.UserID = @Username
				AND A.SUPPLIER_CD = @SUPPLIER_CD
				AND A.SUPPLIER_PLANT = @SUPPLIER_PLANT
				AND A.DOCK_CD = @DOCK_CD

			--PRINT 11
			SET @log = 'Insert into TB_R_DAILY_ORDER_MANIFEST, Manifest no :' + @MANIFEST_NO + ', Order No :' + @ORDER_NO + ', Dock :' + @DOCK_CD;

			INSERT INTO @TB_T_LOG_D
			SELECT @pid
				,NULL
				,'MPCS00002INF'
				,'INF'
				,@log
				,'Insert Emergency Order'
				,@Username
				,GETDATE()

			SELECT TOP 1 @PC_ADDRESS_FINAL = ISNULL(a.PC_ADDRESS, '')
			FROM TB_T_CED_EMERGENCY_ORDER_PART t
			LEFT JOIN TB_M_ARS a ON t.PART_NO = a.PART_NO
				AND a.DOCK_CD = t.DOCK_CD
				AND a.SUPPLIER_CD = t.SUPPLIER_CD
				AND a.SUPPLIER_PLANT = t.SUPPLIER_PLANT
			WHERE t.SessionID = @SessionID
				AND t.UserID = @Username
				AND t.SUPPLIER_CD = @SUPPLIER_CD
				AND t.SUPPLIER_PLANT = @SUPPLIER_PLANT
				AND t.DOCK_CD = @DOCK_CD

			--SELECT TOP 1 @BUILD_OUT_QTY = ISNULL(p.BUILD_OUT_QTY,0)
			--FROM TB_T_EMERGENCY_ORDER_PART t
			--INNER JOIN TB_R_DAILY_ORDER_MANIFEST m on t.SUPPLIER_CD = m.SUPPLIER_CD AND t.SUPPLIER_PLANT = m.SUPPLIER_PLANT AND t.DOCK_CD = m.DOCK_CD
			--INNER JOIN TB_R_DAILY_ORDER_PART p on m.MANIFEST_NO=m.MANIFEST_NO AND t.KANBAN_NO = p.KANBAN_NO
			--WHERE t.SessionID=@SessionID AND t.UserID=@Username AND
			--	t.SUPPLIER_CD=@SUPPLIER_CD AND
			--	t.SUPPLIER_PLANT=@SUPPLIER_PLANT AND
			--	t.DOCK_CD=@DOCK_CD
			--ORDER BY m.ORDER_RELEASE_DT DESC
			INSERT INTO TB_T_DAILY_ORDER_PART (
				MANIFEST_NO
				,ITEM_NO
				,SUPPLIER_PLANT
				,RCV_PLANT_CD
				,DOCK_CD
				,PART_NO
				,KANBAN_PRINT_ADDRESS
				,KANBAN_NO
				,QTY_PER_CONTAINER
				,ORDER_QTY
				,ORDER_PLAN_QTY_LOT
				,SUPPLIER_NAME
				,PART_NAME
				,ORDER_MODE
				,PACKAGE_TYPE
				,RECEIVED_STATUS
				,KANBAN_PRINT_DATE_PLANT
				,KANBAN_PRINT_DATE_LOCAL
				,RECEIVE_PLANT_NAME
				,IMPORTIR_INFO
				,IMPORTIR_INFO2
				,IMPORTIR_INFO3
				,IMPORTIR_INFO4
				,PART_BARCODE
				,CREATED_BY
				,CREATED_DT
				,CONVEYANCE_ROUTE
				)
			SELECT @MANIFEST_NO
				,ROW_NUMBER() OVER (
					ORDER BY t.PART_NO ASC
					)
				,REPLACE(@SUPPLIER_PLANT, ' ', '')
				,@RCV_PLANT_CD
				,@DOCK_CD
				,t.PART_NO
				,(
					CASE 
						WHEN @PC_ADDRESS_FINAL = ''
							THEN t.KANBAN_PRINT_ADDRESS
						ELSE @PC_ADDRESS_FINAL
						END
					)
				,t.KANBAN_NO
				,t.QTY_PER_CONTAINER
				,(
					CASE 
						WHEN t.PIECES_QTY <> (ISNULL(t.QTY_PER_CONTAINER, 0) * ISNULL(t.ORDER_QTY, 0))
							THEN (ISNULL(t.QTY_PER_CONTAINER, 0) * ISNULL(t.ORDER_QTY, 0))
						ELSE t.PIECES_QTY
						END
					)
				,t.ORDER_QTY
				,s.SUPPLIER_NAME
				,t.PART_NAME
				,NULL
				,sp.PCK_TYPE
				,0
				,@DATE_NOW
				,@DATE_NOW
				,@PLANT_NM
				,t.IMPORTIR_INFO
				,t.IMPORTIR_INFO2
				,t.IMPORTIR_INFO3
				,t.IMPORTIR_INFO4
				,
				--CASE WHEN PART_BARCODE BETWEEN CONVERT(BIGINT, '1') AND CONVERT(BIGINT, '100') THEN '' ELSE PART_BARCODE END PART_BARCODE,
				CASE 
          --** Start : Change by FID.Andri (2022-09-28) -> Dock Checking to EO System Master
          /*
					WHEN t.DOCK_CD IN (
							 '1H'
							,'1J'
							,'1K'
							,'1L'
							,'1M'
							,'1N'
							,'1Q'
							,'1U'
							,'1V'
							,'1W'
							,'1X'
							,'1Y'
							,'1Z'
							,'1R'
							,'H1'
							,'N1'
							,'7Z'
							)
          */
          WHEN t.DOCK_CD IN (SELECT * FROM #tmpSplitStringDock)
          --** End : Change
						THEN PART_BARCODE
					WHEN PART_BARCODE BETWEEN CONVERT(BIGINT, '1')
							AND CONVERT(BIGINT, '100')
						THEN ''
					END PART_BARCODE
				,@Username
				,GETDATE()
				,@CONVEYANCE_NO
			FROM TB_T_CED_EMERGENCY_ORDER_PART t
			LEFT JOIN TB_M_PART_INFO sp WITH (NOLOCK) ON sp.SUPPLIER_CD = t.SUPPLIER_CD
				AND sp.SUPPLIER_PLANT = t.SUPPLIER_PLANT
				AND sp.DOCK_CD = t.DOCK_CD
				AND sp.PART_NO = t.PART_NO
			--LEFT JOIN TB_M_SUPPLIER_PART sp on sp.SUPPLIER_CD=t.SUPPLIER_CD AND sp.SUPPLIER_PLANT=t.SUPPLIER_PLANT AND
			--								sp.REC_DOCK_CD=t.DOCK_CD AND sp.PART_NO=t.PART_NO AND (CONVERT(VARCHAR(8),GETDATE(),112) BETWEEN sp.TIME_FROM AND sp.TIME_TO)
			LEFT JOIN TB_M_SUPPLIER s ON s.SUPPLIER_CODE = t.SUPPLIER_CD
				AND s.SUPPLIER_PLANT_CD = t.SUPPLIER_PLANT
			WHERE t.SessionID = @SessionID
				AND t.UserID = @Username
				AND t.SUPPLIER_CD = @SUPPLIER_CD
				AND t.SUPPLIER_PLANT = @SUPPLIER_PLANT
				AND t.DOCK_CD = @DOCK_CD

			SET @log = 'Insert into TB_R_DAILY_ORDER_PART, Manifest no :' + @MANIFEST_NO;

			INSERT INTO @TB_T_LOG_D
			SELECT @pid
				,NULL
				,'MPCS00002INF'
				,'INF'
				,@log
				,'Insert Emergency Order'
				,@Username
				,GETDATE()

			SET @log = 'Update Total Item and Total Qty on TB_R_DAILY_ORDER_MANIFEST';

			INSERT INTO @TB_T_LOG_D
			SELECT @pid
				,NULL
				,'MPCS00002INF'
				,'INF'
				,@log
				,'Insert Emergency Order'
				,@Username
				,GETDATE()

			UPDATE m
			SET m.TOTAL_ITEM = ISNULL(p.TOTAL_ITEM, 0)
				,m.TOTAL_QTY = ISNULL(p.TOTAL_QTY, 0)
			FROM TB_T_DAILY_ORDER_MANIFEST m
			LEFT JOIN (
				SELECT MANIFEST_NO
					,TOTAL_ITEM = COUNT('')
					,TOTAL_QTY = SUM(ORDER_QTY)
				FROM TB_T_DAILY_ORDER_PART WITH (NOLOCK)
				WHERE ORDER_QTY > 0
				GROUP BY MANIFEST_NO
				) p ON m.MANIFEST_NO = p.MANIFEST_NO
			WHERE m.MANIFEST_NO = @MANIFEST_NO
				AND M.CREATED_BY = @Username

			SET @log = 'Delete TB_T_CED_EMERGENCY_ORDER_PART';

			INSERT INTO @TB_T_LOG_D
			SELECT @pid
				,NULL
				,'MPCS00002INF'
				,'INF'
				,@log
				,'Insert Emergency Order'
				,@Username
				,GETDATE()

			/* Start 2019-02-13 FID.Ridwan */
			--DELETE
			--FROM TB_T_EMERGENCY_ORDER_PART
			--WHERE SessionID = @SessionID
			--	AND UserID = @Username
			--	AND SUPPLIER_CD = @SUPPLIER_CD
			--	AND SUPPLIER_PLANT = @SUPPLIER_PLANT
			--	AND DOCK_CD = @DOCK_CD
			/* End 2019-02-13 FID.Ridwan */
			INSERT INTO #RESULTMANIFEST
			SELECT @MANIFEST_NO
				,@ORDER_NO
				,@DOCK_CD

			SET @iEMERGENCY_ORDER_PART = @iEMERGENCY_ORDER_PART + 1
		END

		/* Start 2019-02-13 FID.Ridwan */
		IF (
				SELECT TOP 1 1
				FROM TB_T_DAILY_ORDER_PART
				WHERE ISNULL(PART_BARCODE, '') = ''
				) = 1
		BEGIN
			IF OBJECT_ID('tempdb..#LIST_EMPTY_BARCODE') IS NOT NULL
				DROP TABLE #LIST_EMPTY_BARCODE

			IF OBJECT_ID('tempdb..#LIST_HAVE_BARCODE') IS NOT NULL
				DROP TABLE #LIST_HAVE_BARCODE

			IF OBJECT_ID('tempdb..#LIST_GENERATE_KANBAN') IS NOT NULL
				DROP TABLE #LIST_GENERATE_KANBAN

			CREATE TABLE #LIST_GENERATE_KANBAN (
				MANIFEST_NO VARCHAR(16)
				,ITEM_NO INT
				,PART_BARCODE VARCHAR(50)
				,SUPPLIER_CD VARCHAR(6)
				,SUPPLIER_PLANT CHAR(1)
				,DOCK_CD VARCHAR(2)
				,PART_NO VARCHAR(50)
				,KANBAN_PRINT_ADDRESS VARCHAR(18)
				,KANBAN_NO VARCHAR(4)
				,QTY_PER_CONTAINER INT
				,ORDER_QTY INT
				,PIECES_QTY INT
				,PART_NAME VARCHAR(40)
				,IMPORTIR_INFO VARCHAR(10)
				,IMPORTIR_INFO2 VARCHAR(10)
				,IMPORTIR_INFO3 VARCHAR(10)
				,IMPORTIR_INFO4 VARCHAR(10)
				,SessionID VARCHAR(50)
				,UserID VARCHAR(50)
				)

			--== Get list where barcode is empty / blank ==--
			SELECT ROW_NUMBER() OVER (
					ORDER BY PART_NO
					) RN
				,*
			INTO #LIST_EMPTY_BARCODE
			FROM TB_T_DAILY_ORDER_PART
			WHERE ISNULL(PART_BARCODE, '') = ''
				AND CREATED_BY = @Username

			--== Get list where data already have barcode ==--
			SELECT *
			INTO #LIST_HAVE_BARCODE
			FROM TB_T_DAILY_ORDER_PART
			WHERE ISNULL(PART_BARCODE, '') <> ''
				AND CREATED_BY = @Username

			--== Delete data from tb t part ==--
			DELETE
			FROM TB_T_DAILY_ORDER_PART
			WHERE MANIFEST_NO IN (
					SELECT MANIFEST_NO
					FROM #LIST_HAVE_BARCODE
					
					UNION ALL
					
					SELECT MANIFEST_NO
					FROM #LIST_EMPTY_BARCODE
					)

			--== Insert into tb t dop from list already have barcode and item no replace with new no / row number ==--
			INSERT INTO TB_T_DAILY_ORDER_PART (
				MANIFEST_NO
				,ITEM_NO
				,SUPPLIER_PLANT
				,RCV_PLANT_CD
				,DOCK_CD
				,PART_NO
				,KANBAN_PRINT_ADDRESS
				,KANBAN_NO
				,QTY_PER_CONTAINER
				,ORDER_QTY
				,ORDER_PLAN_QTY_LOT
				,SUPPLIER_NAME
				,PART_NAME
				,ORDER_MODE
				,PACKAGE_TYPE
				,RECEIVED_STATUS
				,KANBAN_PRINT_DATE_PLANT
				,KANBAN_PRINT_DATE_LOCAL
				,RECEIVE_PLANT_NAME
				,IMPORTIR_INFO
				,IMPORTIR_INFO2
				,IMPORTIR_INFO3
				,IMPORTIR_INFO4
				,PART_BARCODE
				,CREATED_BY
				,CREATED_DT
				,CONVEYANCE_ROUTE
				)
			SELECT MANIFEST_NO
				,ROW_NUMBER() OVER (
					PARTITION BY MANIFEST_NO ORDER BY MANIFEST_NO ASC --PART_NO
					) ITEM_NO
				,SUPPLIER_PLANT
				,RCV_PLANT_CD
				,DOCK_CD
				,PART_NO
				,KANBAN_PRINT_ADDRESS
				,KANBAN_NO
				,QTY_PER_CONTAINER
				,ORDER_QTY
				,ORDER_PLAN_QTY_LOT
				,SUPPLIER_NAME
				,PART_NAME
				,ORDER_MODE
				,PACKAGE_TYPE
				,RECEIVED_STATUS
				,KANBAN_PRINT_DATE_PLANT
				,KANBAN_PRINT_DATE_LOCAL
				,RECEIVE_PLANT_NAME
				,IMPORTIR_INFO
				,IMPORTIR_INFO2
				,IMPORTIR_INFO3
				,IMPORTIR_INFO4
				,PART_BARCODE
				,CREATED_BY
				,CREATED_DT
				,CONVEYANCE_ROUTE
			FROM #LIST_HAVE_BARCODE

			--== Generate kanban where data from list empty barcode (qty barcode based on user upload) ==--
			DECLARE @INDEX INT = 1
				,@INDEX_COUNT INT = 0
			DECLARE @MANIFEST_NO_DET VARCHAR(16)
				,@ITEM_NO_DET INT
				,@SUPPLIER_CD_DET VARCHAR(6)
				,@SUPPLIER_PLANT_DET CHAR(1)
				,@DOCK_CD_DET VARCHAR(2)

			SELECT @INDEX_COUNT = COUNT(1)
			FROM #LIST_EMPTY_BARCODE

			WHILE @INDEX <= @INDEX_COUNT
			BEGIN
				SET @ITEM_NO_DET = 0;

				SELECT @MANIFEST_NO_DET = MANIFEST_NO
					,@SUPPLIER_PLANT_DET = SUPPLIER_PLANT
					,@DOCK_CD_DET = DOCK_CD
				FROM #LIST_EMPTY_BARCODE
				WHERE RN = @INDEX

				SELECT @ITEM_NO_DET = ISNULL(MAX(ITEM_NO), 0)
				FROM TB_T_DAILY_ORDER_PART
				WHERE MANIFEST_NO = @MANIFEST_NO_DET
					AND SUPPLIER_PLANT = @SUPPLIER_PLANT_DET
					AND DOCK_CD = @DOCK_CD_DET

				SELECT DISTINCT @SUPPLIER_CD_DET = SUPPLIER_CD
				FROM TB_T_DAILY_ORDER_MANIFEST
				WHERE MANIFEST_NO = @MANIFEST_NO_DET
					AND SUPPLIER_PLANT = @SUPPLIER_PLANT_DET
					AND DOCK_CD = @DOCK_CD_DET
					
				SET @log = 'Execute SP_GenerateKanban2 stored procedure for Create Kanban 2';

				INSERT INTO @TB_T_LOG_D
				SELECT @pid
					,NULL
					,'MPCS00002INF'
					,'INF'
					,@log
					,'Generate Kanban 2'
					,@Username
					,GETDATE()

				--select @MANIFEST_NO_DET, @ITEM_NO_DET, @SUPPLIER_CD_DET, @SUPPLIER_PLANT_DET, @DOCK_CD_DET, @Username, @SessionID
				INSERT INTO #LIST_GENERATE_KANBAN
				EXEC SP_GenerateKanban2 @Username
					,@SessionID
					,@MANIFEST_NO_DET
					,@ITEM_NO_DET
					,@SUPPLIER_CD_DET
					,@SUPPLIER_PLANT_DET
					,@DOCK_CD_DET
					,0 -- process id 
					,1 -- type
					,NULL 
					,NULL

				--'IPPCS.Admin', 'mtwbaxer1yuwadclqy03fys5'
				SET @INDEX = @INDEX + 1
			END

			--== Insert into tb t dop from list new barcode ==--
			INSERT INTO TB_T_DAILY_ORDER_PART (
				MANIFEST_NO
				,ITEM_NO
				,SUPPLIER_PLANT
				,RCV_PLANT_CD
				,DOCK_CD
				,PART_NO
				,KANBAN_PRINT_ADDRESS
				,KANBAN_NO
				,QTY_PER_CONTAINER
				,ORDER_QTY
				,ORDER_PLAN_QTY_LOT
				,SUPPLIER_NAME
				,PART_NAME
				,ORDER_MODE
				,PACKAGE_TYPE
				,RECEIVED_STATUS
				,KANBAN_PRINT_DATE_PLANT
				,KANBAN_PRINT_DATE_LOCAL
				,RECEIVE_PLANT_NAME
				,IMPORTIR_INFO
				,IMPORTIR_INFO2
				,IMPORTIR_INFO3
				,IMPORTIR_INFO4
				,PART_BARCODE
				,CREATED_BY
				,CREATED_DT
				,CONVEYANCE_ROUTE
				)
			SELECT DISTINCT T.MANIFEST_NO
				,T.ITEM_NO
				,T.SUPPLIER_PLANT
				,S.RCV_PLANT_CD
				,T.DOCK_CD
				,t.PART_NO
				,T.KANBAN_PRINT_ADDRESS
				,t.KANBAN_NO
				,t.QTY_PER_CONTAINER
				--,(
				--	CASE 
				--		WHEN t.PIECES_QTY <> (ISNULL(t.QTY_PER_CONTAINER, 0) * ISNULL(t.ORDER_QTY, 0))
				--			THEN (ISNULL(t.QTY_PER_CONTAINER, 0) * ISNULL(t.ORDER_QTY, 0))
				--		ELSE t.PIECES_QTY
				--		END
				--	)
				--,t.ORDER_QTY
				,t.QTY_PER_CONTAINER AS ORDER_QTY
				,1 AS ORDER_PLAN_QTY_LOT
				,s.SUPPLIER_NAME
				,t.PART_NAME
				,NULL
				,s.PACKAGE_TYPE
				,0
				,S.KANBAN_PRINT_DATE_PLANT
				,S.KANBAN_PRINT_DATE_LOCAL
				,S.RECEIVE_PLANT_NAME
				,t.IMPORTIR_INFO
				,t.IMPORTIR_INFO2
				,t.IMPORTIR_INFO3
				,t.IMPORTIR_INFO4
				,T.PART_BARCODE
				,T.UserID
				,GETDATE()
				,S.CONVEYANCE_ROUTE
			FROM #LIST_GENERATE_KANBAN t
			LEFT JOIN #LIST_EMPTY_BARCODE S ON T.MANIFEST_NO = S.MANIFEST_NO
				AND T.SUPPLIER_PLANT = S.SUPPLIER_PLANT
				AND T.DOCK_CD = S.DOCK_CD
				AND T.PART_NO = S.PART_NO
		END

		--= Insert into permanent Table =--
		INSERT INTO TB_R_DAILY_ORDER_MANIFEST (
			ORDER_NO
			,MANIFEST_NO
			,SUPPLIER_CD
			,SUPPLIER_PLANT
			,ORDER_TYPE
			,ORDER_RELEASE_DT
			,RCV_PLANT_CD
			,DOCK_CD
			,P_LANE_CD
			,P_LANE_SEQ
			,ARRIVAL_PLAN_DT
			,TOTAL_ITEM
			,TOTAL_QTY
			,SHIPPING_DOCK
			,SHIPPING_DT
			,SUB_ROUTE_CD
			,SUB_ROUTE_SEQ
			,SUB_ROUTE_DT
			,FST_X_DOCK_DEPART_DT
			,COMPANY_CD
			,CAR_FAMILY_CD
			,RE_EXPORT_CD
			,CANCEL_FLAG
			,MANIFEST_RECEIVE_FLAG
			,PROBLEM_FLAG
			,ICS_FLAG
			,ICS_DT
			,CREATED_BY
			,CREATED_DT
			,FTP_FLAG
			,CONVEYANCE_ROUTE
			)
		SELECT DISTINCT ORDER_NO
			,MANIFEST_NO
			,SUPPLIER_CD
			,SUPPLIER_PLANT
			,ORDER_TYPE
			,ORDER_RELEASE_DT
			,RCV_PLANT_CD
			,DOCK_CD
			,P_LANE_CD
			,P_LANE_SEQ
			,ARRIVAL_PLAN_DT
			,TOTAL_ITEM
			,TOTAL_QTY
			,SHIPPING_DOCK
			,SHIPPING_DT
			,SUB_ROUTE_CD
			,SUB_ROUTE_SEQ
			,SUB_ROUTE_DT
			,FST_X_DOCK_DEPART_DT
			,COMPANY_CD
			,CAR_FAMILY_CD
			,RE_EXPORT_CD
			,CANCEL_FLAG
			,MANIFEST_RECEIVE_FLAG
			,PROBLEM_FLAG
			,ICS_FLAG
			,ICS_DT
			,CREATED_BY
			,CREATED_DT
			,FTP_FLAG
			,CONVEYANCE_ROUTE
		FROM TB_T_DAILY_ORDER_MANIFEST
		WHERE CREATED_BY = @Username
			AND LEFT(MANIFEST_NO,1) = 'E'

		INSERT INTO TB_R_DAILY_ORDER_PART (
			MANIFEST_NO
			,ITEM_NO
			,SUPPLIER_PLANT
			,RCV_PLANT_CD
			,DOCK_CD
			,PART_NO
			,KANBAN_PRINT_ADDRESS
			,KANBAN_NO
			,QTY_PER_CONTAINER
			,ORDER_QTY
			,ORDER_PLAN_QTY_LOT
			,SUPPLIER_NAME
			,PART_NAME
			,ORDER_MODE
			,PACKAGE_TYPE
			,RECEIVED_STATUS
			,KANBAN_PRINT_DATE_PLANT
			,KANBAN_PRINT_DATE_LOCAL
			,RECEIVE_PLANT_NAME
			,IMPORTIR_INFO
			,IMPORTIR_INFO2
			,IMPORTIR_INFO3
			,IMPORTIR_INFO4
			,PART_BARCODE
			,CREATED_BY
			,CREATED_DT
			,CONVEYANCE_ROUTE
			)
		SELECT DISTINCT MANIFEST_NO
			,ITEM_NO
			,SUPPLIER_PLANT
			,RCV_PLANT_CD
			,DOCK_CD
			,PART_NO
			,KANBAN_PRINT_ADDRESS
			,KANBAN_NO
			,QTY_PER_CONTAINER
			,ORDER_QTY
			,ORDER_PLAN_QTY_LOT
			,SUPPLIER_NAME
			,PART_NAME
			,ORDER_MODE
			,PACKAGE_TYPE
			,RECEIVED_STATUS
			,KANBAN_PRINT_DATE_PLANT
			,KANBAN_PRINT_DATE_LOCAL
			,RECEIVE_PLANT_NAME
			,IMPORTIR_INFO
			,IMPORTIR_INFO2
			,IMPORTIR_INFO3
			,IMPORTIR_INFO4
			,PART_BARCODE
			,CREATED_BY
			,CREATED_DT
			,CONVEYANCE_ROUTE
		FROM TB_T_DAILY_ORDER_PART
		WHERE CREATED_BY = @Username
			AND LEFT(MANIFEST_NO,1) = 'E'

		/* End 2019-02-13 FID.Ridwan */
		--RAISERROR('abc', 16, 1)
		SET @log = 'Finish [Insert Emergency Order]';

		INSERT INTO @TB_T_LOG_D
		SELECT @pid
			,NULL
			,'MPCS00002INF'
			,'INF'
			,@log
			,'Insert Emergency Order'
			,@Username
			,GETDATE()

		SELECT TOP 1 @R_SEQ_NO = SEQUENCE_NUMBER
		FROM TB_R_LOG_D
		WHERE PROCESS_ID = @pid
		ORDER BY SEQUENCE_NUMBER DESC

		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT PROCESS_ID
			,@R_SEQ_NO + ROW_NUMBER() OVER (
				ORDER BY PROCESS_ID
				)
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
		FROM @TB_T_LOG_D

		UPDATE TB_R_LOG_H
		SET PROCESS_STATUS = 1
		WHERE PROCESS_ID = @pid

		DELETE
		FROM TB_T_CED_EMERGENCY_ORDER_PART
		WHERE SessionID = @SessionID
			AND UserID = @Username

		COMMIT TRANSACTION IPPCSInsertEmergencyOrder

		SELECT DISTINCT MANIFEST_NO
			,ORDER_NO
			,DOCK_CD
		FROM TB_T_DAILY_ORDER_MANIFEST
		WHERE LEFT(MANIFEST_NO,1) = 'E'
	END TRY

	BEGIN CATCH
		ROLLBACK TRANSACTION IPPCSInsertEmergencyOrder;

		SET @log = 'Finish With Error [Insert Emergency Order]';

		INSERT INTO @TB_T_LOG_D
		SELECT @pid
			,NULL
			,'MPCS00002INF'
			,'INF'
			,@log
			,'Insert Emergency Order'
			,@Username
			,GETDATE()

		SELECT TOP 1 @R_SEQ_NO = SEQUENCE_NUMBER
		FROM TB_R_LOG_D
		WHERE PROCESS_ID = @pid
		ORDER BY SEQUENCE_NUMBER DESC

		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT PROCESS_ID
			,@R_SEQ_NO + ROW_NUMBER() OVER (
				ORDER BY PROCESS_ID
				)
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
		FROM @TB_T_LOG_D

		UPDATE TB_R_LOG_H
		SET PROCESS_STATUS = 6
		WHERE PROCESS_ID = @pid

		DECLARE @ErrorMessage NVARCHAR(4000);
		DECLARE @ErrorSeverity INT;
		DECLARE @ErrorState INT;

		SELECT @ErrorMessage = ERROR_MESSAGE()
			,@ErrorSeverity = ERROR_SEVERITY()
			,@ErrorState = ERROR_STATE();

		-- Use RAISERROR inside the CATCH block to return error
		-- information about the original error that caused
		-- execution to jump to the CATCH block.
		RAISERROR (
				@ErrorMessage
				,-- Message text.
				@ErrorSeverity
				,-- Severity.
				@ErrorState -- State.
				);

		RETURN
	END CATCH
END

GO